<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: Shop-Buy.php
//      Used when buying something from the shop.
//		This is not called directly. The code in here is used in Shop.php

// VERSION: 2.2 (Build 10)
// $Date: 2006-07-29 19:39:33 +1000 (Sat, 29 Jul 2006) $
// $Id: Shop-Buy.php 10 2006-07-29 09:39:33Z daniel15 $

if (!defined('SMF'))
	die('Hacking attempt...');
	
	
if ($_GET['do'] == "buy") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=buy",
		'name' => $txt['shop_buy'],
	);
	
	if (!isset($_GET['sort'])) $_GET['sort'] = "0";
	if (!isset($_GET['sortDir'])) $_GET['sortDir'] = "0";
	
	switch($_GET['sort']) {
		case 0:
			$sortType = $txt['shop_name'];
			$sortQuery = "name";
			break;
		case 1:
			$sortType = $txt['shop_price'];
			$sortQuery = "price";
			break;
		case 2:
			$sortType = $txt['shop_description'];
			$sortQuery = "`desc`";
			break;
		case 3:
			$sortType = $txt['shop_stock'];
			$sortQuery = "stock";
			break;
		default:
			die("Invalid sort method passed");
			break;
	}
	
	switch($_GET['sortDir']) {
		case 0:
			$sortDirType = $txt['shop_asc'];
			$sortDirQuery = "ASC";
			break;
		case 1:
			$sortDirType = $txt['shop_desc'];
			$sortDirQuery = "DESC";
			break;	
		default:
			die("Invalid sort method passed");
			break;
	}	
	

	$context['shop_items_list'] = "
<tr>
	<td align='right' colspan='4'>
		<form action='$scripturl' method='GET'>
			<i>".sprintf($txt['shop_sort'], $sortType, $sortDirType)."
			<input type='hidden' name='action' value='shop'>
			<input type='hidden' name='do' value='buy'>
			<select name='sort'>
				<option value='0'>{$txt['shop_name']}</option>
				<option value='1'>{$txt['shop_price']}</option>
				<option value='2'>{$txt['shop_description']}</option>
				<option value='3'>{$txt['shop_stock']}</option>
			</select>
			
			<select name='sortDir'>
				<option value='0'>{$txt['shop_asc']}</option>
				<option value='1'>{$txt['shop_desc']}</option>
			</select>
			
			<input type='submit' value='Go'>
		</form>
	</td>
</tr>

<tr valign='top' class='windowbg'>
	<td style='padding-bottom: 2ex;' width='32'>
		<b>{$txt['shop_image']}</b>
	</td>
	<td>
		<b>{$txt['shop_name']}</b>
	</td>
	<td>
		<b>{$txt['shop_description']}</b>
	</td>
	<td width='18%'>
		<b>{$txt['shop_price']}/{$txt['shop_stock']}</b>
	</td>
</tr>";


	$result = db_query("SELECT money
						FROM {$db_prefix}members
						WHERE ID_MEMBER = $ID_MEMBER
						LIMIT 1", __FILE__, __LINE__);
	
	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	$usersmoney = $row['money'];

	$alternating = "windowbg2";
	$itemRows = array();
	
	$result = db_query("SELECT name, `desc`, price, stock, id, image
						FROM {$db_prefix}shop_items
						ORDER BY {$sortQuery} {$sortDirQuery}", __FILE__, __LINE__);

	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		$itemRows[] = $row;
	}
	
	if (!isset($_GET['page'])) $_GET['page'] = 1;
	if (!isset($modSettings['shopItemsPerPage'])) $modSettings['shopItemsPerPage'] = 15;
	
	$pageCount = ceil(count($itemRows) / $modSettings['shopItemsPerPage']);
	$firstItem = ($_GET['page'] * $modSettings['shopItemsPerPage']) - $modSettings['shopItemsPerPage'];
	
	for ($x = $firstItem; ($x < $firstItem + $modSettings['shopItemsPerPage']) && ($x < count($itemRows)) ; $x++) {
	
		$context['shop_items_list'] .= "
<tr valign='top' class='{$alternating}'>
	<td>
		<img border='0' width='{$modSettings['shopImageWidth']}' height='{$modSettings['shopImageHeight']}' src='{$boardurl}/Sources/shop/item_images/{$itemRows[$x]['image']}'>
	</td>
	<td style='padding-bottom: 2ex;' width='20%'>
		{$itemRows[$x]['name']}
	</td>
	<td>
		{$itemRows[$x]['desc']}
	</td>
	<td width='18%'>
		{$txt['shop_price']}: {$itemRows[$x]['price']}<br />
		{$txt['shop_stock']}: {$itemRows[$x]['stock']}<br />";

		if ($usersmoney >= $itemRows[$x]['price']) {
			$context['shop_items_list'] .= "<a href='$scripturl?action=shop;do=buy2;id={$itemRows[$x]['id']}'>{$txt['shop_buynow']}</a>";
		} elseif ($itemRows[$x]['stock'] == 0) {
			$context['shop_items_list'] .= "<b>{$txt['shop_soldout']}</b>";
		} else {
			$context['shop_items_list'] .= "<b>".sprintf($txt['shop_need'], formatMoney($itemRows[$x]['price'] - $usersmoney))."</b>";
		}

		$context['shop_items_list'] .= "
		<br /><a href='$scripturl?action=shop;do=owners;id={$itemRows[$x]['id']}'>{$txt['shop_owners']}</a>
</td></tr>";

		if ($alternating == "windowbg") {
			$alternating = "windowbg2";
		} else {
			$alternating = "windowbg";
		}
	} 
	
	$context['shop_pages'] = $pageCount;
	$context['shop_current_page'] = $_GET['page'];
	$context['shop_page_link'] = $scripturl."?action=shop;do=buy;sort=".$_GET['sort'].";sortDir=".$_GET['sortDir'];
	$context['sub_template'] = "inventory";
	loadTemplate('Shop');
	
} elseif ($_GET['do'] == "buy2") {
	$context['linktree'][] = array(
		'url' => "$scripturl?action=shop;do=buy",
		'name' => $txt['shop_buy'],
	);

	//user's money
	$result = db_query("SELECT money
						FROM {$db_prefix}members
						WHERE ID_MEMBER = {$ID_MEMBER}
						LIMIT 1", __FILE__, __LINE__);
	
	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	$usersmoney = $row['money'];

	//item information
	$result = db_query("SELECT price, stock, name
						FROM {$db_prefix}shop_items
						WHERE id = {$_GET['id']}
						LIMIT 1", __FILE__, __LINE__);
	$row = mysql_fetch_array($result, MYSQL_ASSOC);


	if ($usersmoney < $row['price']) {
		//$context['shop_buy_message'] = sprintf($txt['shop_not_enough_money'], $cost - $usersmoney);
		$context['shop_buy_message'] = sprintf($txt['shop_need'], formatMoney($row['price'] - $usersmoney));
	} elseif ($row['stock'] == 0) {
		$context['shop_buy_message'] = $txt['shop_soldout_full'];
	} else {

		//put item in user's inventory
		$result = db_query("INSERT
							INTO {$db_prefix}shop_inventory
							(ownerid, itemid, amtpaid)
							VALUES (
									{$ID_MEMBER},
									{$_GET['id']},
									{$row['price']})",
									__FILE__, __LINE__);

		//decrease user's money
		$result = db_query("UPDATE {$db_prefix}members
							SET money = money - {$row['price']}
							WHERE ID_MEMBER = {$ID_MEMBER}
							LIMIT 1",
							__FILE__, __LINE__);

		//decrease stock by 1
		$result = db_query("UPDATE {$db_prefix}shop_items
							SET stock = stock - 1
							WHERE id = {$_GET['id']}
							LIMIT 1",
							__FILE__, __LINE__);

		$context['shop_buy_message'] = sprintf($txt['shop_bought_item'], $row['name']);
	}
	
	$context['sub_template'] = "message";
	loadTemplate('Shop');
}
?>