<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2005 DanSoft Australia           |
|      http://www.dansoftaustralia.com/        |
\**********************************************/

//File: item_engine.php
//      Item back engine [what else can i call it...? ;)]

//VERSION: 1.1 (Build 4)
//DATE: 10th April 2005
// $Id: item_engine.php 4 2006-07-08 10:09:08Z daniel15 $

class itemTemplate {
    var $name = "No Name Specified";
    var $desc = "No Description Specified";
    var $price = 20;

    var $require_input = true; //set to 'true' for backwards compatability
    var $can_use_item = true;

    //called when we need to get the item details. Here, you should fill in the $name, 
    //$desc and $price variables.
    function getItemDetails() {}
    
    //called when person is adding this item to their SMFShop installation via the admin
    //panel. If you need any additional fields, then return them here 
    //(see items/AddToPostCount.php for an example).
    function getAddInput() {}

    //called when person tries to use item. This is used to get input for the item.
    //If item needs no input then just return false here
    function getUseInput() {}

    //called when item is actually used
    function onUse() {}
}

?>
