<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2005 DanSoft Australia           |
|      http://www.dansoftaustralia.com/        |
\**********************************************/

//File: rock.php
//      Rock Item (does nothing)

//VERSION: 1.1 (Build 4)
//DATE: 10th April 2005
// $Id: Rock.php 3 2006-07-08 10:01:21Z daniel15 $

//your class should always be called item_filename, eg. if your file is 
//myCoolItem.php then the class should be called 'item_myCoolItem'. This 
//class should always extend itemTemplate.
class item_rock extends itemTemplate {
    
    //when this function is called, you should set all the item's
    //variables (see inside this example)
    function getItemDetails() {

        //VALUES CHANGABLE FROM WITHIN ADMIN PANEL:
          //the name of the item
          $this->name = "Rock";
          //the item's description
          $this->desc = "Well.... It does nothing";
          //the item's price
          $this->price = 5;
          
        //UNCHANGABLE VALUES:
          //whether the item requires input or not. In this case, we don't need
          //any input
          $this->require_input = false;
          //since this is a rock (you can't use it), we set this to false
          $this->can_use_item = false;
    }

    //since this item requires no input, we don't need to have a getUseInput function
    //here (see the testitem2.php file if you want to make an item that needs input)


    //also, since this is a rock, you don't need an onUse function (since it doesn't get used)
}


?>
