<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: Shop.php
//      The main shop file

// VERSION: 2.2 (Build 10)
// $Date: 2006-07-29 20:17:45 +1000 (Sat, 29 Jul 2006) $
// $Id: Shop.php 13 2006-07-29 10:17:45Z daniel15 $

if (!defined('SMF'))
	die('Hacking attempt...');

function Shop(){
	//global $db_prefix, $context, $scripturl, $user_info, $txt, $modSettings, $ID_MEMBER, $themeUser;

    global $context, $modSettings, $scripturl, $db_prefix, $ID_MEMBER, $txt, $item_info, $boardurl, $sourcedir;
	
	//Required for sending IM's
	include_once($sourcedir . '/Subs-Post.php');
	loadLanguage("InstantMessage");
    
    //during testing, caching was causing many problems. So, we try to disable the caching
    //here.
    header("Expires: Fri, 1 Jun 1990 00:00:00 GMT"); //my birthday ;)
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
    header("Pragma: no-cache");

    loadLanguage('Shop');
    //check if guest is trying to access
    is_not_guest($txt['shop_guest_message']);
    //loadTemplate('Shop');

    $context['page_title'] = $txt['shop'];
    $context['linktree'][] = array(
        'url' => "$scripturl?action=shop",
        'name' => $txt['shop'],
		);

    //This needs to be here to fix the problem of the 'Bank' link disappearing when on any
    //page other than the index
    if ($modSettings['shopBankEnabled']) {
        $context['shop_bank_link'] = "<a href='$scripturl?action=shop;do=bank'>{$txt['shop_bank']}</a><br />";
    } else {
        $context['shop_bank_link'] = "";
    }
	
	//If trade centre disabled, don't show it.
	$context['shop_trade_link'] = ($modSettings['shopTradeEnabled']) ? "<a href='$scripturl?action=shop;do=trade'>{$txt['shop_trade']}</a><br />" : "";

    if (empty($_GET['do']) || $_GET['do'] == "home") {
        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop",
            'name' => "{$txt['shop']} Home",
        ); 

        //10 richest people (pocket)
        $context['shop_richest'] = "";
        $result = db_query("SELECT realName, money
                            FROM {$db_prefix}members
                            ORDER BY money DESC, realName
                            LIMIT 10", __FILE__, __LINE__);
        
        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
            $context['shop_richest'] .= "<b>{$row['realName']}</b> - ".formatMoney($row['money'])."<br />\r\n";
        }

        //10 richest people (pocket)
        $context['shop_richestBank'] = "";
        $result = db_query("SELECT realName, moneyBank
                            FROM {$db_prefix}members
                            ORDER BY moneyBank DESC, realName
                            LIMIT 10", __FILE__, __LINE__);
        
        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
            $context['shop_richestBank'] .= "<b>{$row['realName']}</b> - ".formatMoney($row['moneyBank'])."<br />\r\n";
        }

        $context['shop_newtopic'] = formatMoney($modSettings['shopPointsPerTopic']);
        $context['shop_newpost'] = formatMoney($modSettings['shopPointsPerPost']);

        //member's money
        $result = db_query("SELECT money, moneyBank
                            FROM {$db_prefix}members
                            WHERE ID_MEMBER = $ID_MEMBER
                            LIMIT 1", __FILE__, __LINE__);
        
        $row = mysql_fetch_array($result, MYSQL_ASSOC);

        $context['shop_money'] = formatMoney($row['money']);
        $context['shop_money_bank'] = formatMoney($row['moneyBank']);
        
		if ($modSettings['shopBankEnabled']) {
			$context['shop_bank_info'] = "<br /><b>{$txt['shop_bankinterest']}: </b>{$modSettings['shopInterest']}% per day<br />";
			$context['shop_money_in_bank'] = "<b>{$txt['shop_money_in_bank']}: </b>{$context['shop_money_bank']}";
	
		} else {
			$context['shop_bank_info'] = "";
			$context['shop_money_in_bank'] = "";
		}
		
		$context['sub_template'] = "main";
		loadTemplate('Shop');

	// All of this code is in external files, to keep this Shop.php file relatively small :)
	} elseif (substr($_GET['do'], 0, 3) == "buy") {
		require "Shop-Buy.php";
	} elseif (substr($_GET['do'], 0, 3) == "inv" || substr($_GET['do'], 0, 8) == "invother") {
		require "Shop-Inventory.php";
	} elseif (substr($_GET['do'], 0, 4) == "send") {
		require "Shop-Send.php";
	} elseif (substr($_GET['do'], 0, 4) == "bank" || $_GET['do'] == "deposit" || $_GET['do'] == "withdraw") {
		require "Shop-Bank.php";
	} elseif (substr($_GET['do'], 0, 5) == "trade") {
		require "Shop-Trade.php";
		
    } elseif($_GET['do'] == "viewall") {

        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=viewall",
            'name' => $txt['shop_view_all'],
        );

        $context['shop_buy_message'] = "";
        $result = db_query("SELECT memberName, money
                            FROM {$db_prefix}members
                            WHERE money <> 0
                            ORDER BY money DESC
                            ", __FILE__, __LINE__);

        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
            $context['shop_buy_message'] .= "<b>{$row['memberName']}</b> - ".formatMoney($row['money'])."<br />\r\n";
        }
		
		$context['sub_template'] = "message";
		loadTemplate('Shop');

    } elseif($_GET['do'] == "viewallBank") {

        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=viewallBank",
            'name' => $txt['shop_view_all2'],
        );

        $context['shop_buy_message'] = "";
        $result = db_query("SELECT memberName, moneyBank
                            FROM {$db_prefix}members
                            WHERE moneyBank <> 0
                            ORDER BY moneyBank DESC
                            ", __FILE__, __LINE__);

        while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
            $context['shop_buy_message'] .= "<b>{$row['memberName']}</b> - ".formatMoney($row['moneyBank'])."<br />\r\n";
        }
		
		$context['sub_template'] = "message";
		loadTemplate('Shop');

		
    } elseif($_GET['do'] == "owners") {

        $context['linktree'][] = array(
            'url' => "$scripturl?action=shop;do=owners;id={$_GET['id']}",
            'name' => $txt['shop_owners'],
        );
		
		// Get item name
		$result = db_query("SELECT name
							 FROM {$db_prefix}shop_items
							 WHERE id = {$_GET['id']}
							 LIMIT 1", __FILE__, __LINE__);
							 
		$row = mysql_fetch_assoc($result);
							 
		// Now, get the actual usernames
		$result = db_query("SELECT DISTINCT  m.realName
							 FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it, {$db_prefix}members AS m
							 WHERE inv.itemid = {$_GET['id']} AND m.ID_MEMBER = inv.ownerid", __FILE__, __LINE__);
							 
		
		$context['shop_buy_message'] = "<b>".sprintf($txt['shop_users_own_item'], (int) mysql_num_rows($result), $row['name'])."</b><ul>";
									 
		while ($row = mysql_fetch_assoc($result)) {
			$context['shop_buy_message'] .= "<li>".$row['realName']."</li>";
		}
		
		$context['shop_buy_message'] .= "</ul>";
		$context['sub_template'] = "message";
		loadTemplate('Shop');
		
		
    } else {
        die("What do I do with {$_GET['do']}? HUH????");
    }
}

function formatMoney($money) {
    global $modSettings;

    $money = (int) $money;
    return $modSettings['shopCurrencyPrefix'].$money.$modSettings['shopCurrencySuffix'];
}
?>
