<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2005 DanSoft Australia           |
|           http://dansoftaus.uni.cc/          |
\**********************************************/

//File: ChangeDisplayName.php
//      Item

//VERSION: 1.2 (Build 5)
//DATE: 9th July 2005
// $Id: ChangeDisplayName.php 3 2006-07-08 10:01:21Z daniel15 $


class item_ChangeDisplayName extends itemTemplate {
	var $minLength = 5;

    function getItemDetails() {
        $this->name = "Change Display Name";
        $this->desc = "Change your display name!";
        $this->price = 50;
    }

    function getUseInput() {
        return "New Display Name: <input type='text' name='newDisplayName' size='50'><br>
                Please choose a name which is at least {$this->minLength} characters long.";
    }

    function onUse() {
        global $db_prefix, $ID_MEMBER;

	if (strlen($_POST['newDisplayName']) < $this->minLength) 
		die("ERROR: The name you chose was not long enough! Please go back and choose a name which is at least {$this->minLength} characters long.");

        $result = db_query("UPDATE {$db_prefix}members
                            SET realName = '{$_POST['newDisplayName']}'
                            WHERE ID_MEMBER = {$ID_MEMBER}",
                            __FILE__, __LINE__);
        return "Successfully changed your display name to {$_POST['newDisplayName']}";
    }

}

?>
