<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2005 DanSoft Australia           |
|      http://www.dansoftaustralia.com/        |
\**********************************************/

//File: AddToPostCount.php
//      Item

//VERSION: 1.1 (Build 4)
//DATE: 10th April 2005
// $Id: IncreaseTimeLoggedIn.php 3 2006-07-08 10:01:21Z daniel15 $

class item_IncreaseTimeLoggedIn extends itemTemplate {
    function getItemDetails() {
        $this->name = "Increase Total Time by xxx";
        $this->desc = "Increase your total time logged in by xxx (default is 12 hours)";
        $this->price = 50;
        
        $this->require_input = false;
        $this->can_use_item = true;
    }
    
    //for more info on this, see AddToPostCount item (AddToPostCount.php)
    function getAddInput() {
        return "Amount to increase total time by (in seconds): <input type='text' name='info1' value='43200'>";
    }

    function getUseInput() {
        return "";
    }

    function onUse() {
        global $db_prefix, $ID_MEMBER, $item_info;

        $result = db_query("UPDATE {$db_prefix}members
                            SET totalTimeLoggedIn = totalTimeLoggedIn + {$item_info[1]}
                            WHERE ID_MEMBER = {$ID_MEMBER}",
                            __FILE__, __LINE__);

        $time_hours = $item_info[1] / 3600;
        return "Successfully added {$item_info[1]} seconds ({$time_hours} hours) to total logged in time.";
    }

}

?>
