<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: RandomMoney.php
//      Item

//VERSION: 2.1 (Build 9)
//DATE: 11th March 2006
// $Id: RandomMoney.php 17 2006-08-12 05:23:46Z daniel15 $

class item_RandomMoney extends itemTemplate {
    function getItemDetails() {
        $this->name = "Random Money (between xxx and xxx)";
        $this->desc = "Get a random amount of money, between xxx and xxx!";
        $this->price = 75;
        
        $this->require_input = false;
        $this->can_use_item = true;
    }

    //See AddToPostCount.php for more information
    function getAddInput() {
        return "Minimum amount winnable: <input type='text' name='info1' value='-190'><br>
                Maximum amount winnable: <input type='text' name='info2' value='190'>";
    }

    function onUse() {
        global $db_prefix, $ID_MEMBER, $item_info;
        
        //simple fix for the 'number expected' errors
        if (!isset($item_info[1]) || $item_info[1] == "")
            $item_info[1] = -190;

        if (!isset($item_info[2]) || $item_info[2] == "")
            $item_info[2] = 190;

        $amount = mt_rand($item_info[1], $item_info[2]);
		
		if ($amount < 0) {
			$result = db_query("SELECT money
								 FROM {$db_prefix}members
								 WHERE ID_MEMBER = {$ID_MEMBER}",
								 __FILE__, __LINE__);
			
			$row = mysql_fetch_array($result, MYSQL_ASSOC);
			
			$amountLoss = abs($amount);
			if ($row['money'] > $amountLoss) {
				$result = db_query("UPDATE {$db_prefix}members
									SET money = money - {$amountLoss}
									WHERE ID_MEMBER = {$ID_MEMBER}",
									__FILE__, __LINE__);
				return "You lost ".formatMoney(	$amountLoss)."!";
			} else {
				$result = db_query("UPDATE {$db_prefix}members
									SET moneyBank = moneyBank - {$amountLoss}
									WHERE ID_MEMBER = {$ID_MEMBER}",
									__FILE__, __LINE__);
				return "You lost ".formatMoney(	$amountLoss)."!<br /><br />You didn't have enough money in your pocket, so the money was taken from your bank! :(";
			}
		} else {
			$result = db_query("UPDATE {$db_prefix}members
								SET money = money + {$amount}
								WHERE ID_MEMBER = {$ID_MEMBER}",
								__FILE__, __LINE__);
			return "You got ".formatMoney($amount)."!";
		}
    }

}

?>
